<?php

# This file was generated during the installation of `wp-mirror'.  If
# you make manual changes, please add comments (e.g. your name and
# date) in case you need to revert them later.

if       ( preg_match( '/^(.*)\.wp-mirror.site$/',    $_SERVER['SERVER_NAME'], 
                                                      $matches ) ) {
     $langcode = $matches[1];
     $project  = 'wikipedia';
     $wiki     = $langcode . 'wiki';
} elseif ( preg_match( '/^(.*)\.wikibooks.site$/',    $_SERVER['SERVER_NAME'], 
                                                      $matches ) ) {
     $langcode = $matches[1];
     $project  = 'wikibooks';
     $wiki     = $langcode . $project;
} elseif ( preg_match( '/^(.*)\.wikimedia.site$/',    $_SERVER['SERVER_NAME'], 
                                                      $matches ) ) {
     $langcode = $matches[1];
     $project  = 'wikimedia';
     $wiki     = $langcode . $project;
} elseif ( preg_match( '/^(.*)\.wikinews.site$/',     $_SERVER['SERVER_NAME'], 
                                                      $matches ) ) {
     $langcode = $matches[1];
     $project  = 'wikinews';
     $wiki     = $langcode . $project;
} elseif ( preg_match( '/^(.*)\.wikipedia.site$/',    $_SERVER['SERVER_NAME'], 
                                                      $matches ) ) {
     $langcode = $matches[1];
     $project  = 'wikipedia';
     $wiki     = $langcode . 'wiki';
} elseif ( preg_match( '/^(.*)\.wikiquote.site$/',    $_SERVER['SERVER_NAME'], 
                                                      $matches ) ) {
     $langcode = $matches[1];
     $project  = 'wikiquote';
     $wiki     = $langcode . $project;
} elseif ( preg_match( '/^(.*)\.wikisource.site$/',   $_SERVER['SERVER_NAME'], 
                                                      $matches ) ) {
     $langcode = $matches[1];
     $project  = 'wikisource';
     $wiki     = $langcode . $project;
} elseif ( preg_match( '/^(.*)\.wikiversity.site$/',  $_SERVER['SERVER_NAME'], 
                                                      $matches ) ) {
     $langcode = $matches[1];
     $project  = 'wikiversity';
     $wiki     = $langcode . $project;
} elseif ( preg_match( '/^(.*)\.wikivoyage.site$/',   $_SERVER['SERVER_NAME'], 
                                                      $matches ) ) {
     $langcode = $matches[1];
     $project  = 'wikivoyage';
     $wiki     = $langcode . $project;
} elseif ( preg_match( '/^(.*)\.wiktionary.site$/',   $_SERVER['SERVER_NAME'], 
                                                      $matches ) ) {
     $langcode = $matches[1];
     $project  = 'wiktionary';
     $wiki     = $langcode . $project;
} elseif ( preg_match( '/^(.*)\.template.site$/',     $_SERVER['SERVER_NAME'], 
                                                      $matches ) ) {
     $langcode = $matches[1]; # this branch is for 'update_farm.php'
     $project  = 'wp-mirror';
     $wiki     = $langcode;
} elseif ( preg_match( '/^(.*)\.wikidata.site$/',     $_SERVER['SERVER_NAME'], 
                                                      $matches ) ) {
     $langcode = 'wikidata';
     $project  = 'wikipedia';
     $wiki     = 'wikidatawiki';
} else {
     die( 'Invalid host name: ' . $_SERVER['SERVER_NAME'] 
                                . ' Cannot determine wiki name' );
}
 
# beware site is `zh-classicalwiki', but database is `zh_classicalwiki'
$wgDBname               = str_replace("-", "_", $wiki);
$wgDBprefix             = '';
if      ( preg_match( '/^(.*)\.wikidata.site$/',     $_SERVER['SERVER_NAME'], 
                                                      $matches ) ) {
     $wgServer          = 'http://www.wikidata.site';
     $wgMetaNamespace   = 'Wikidata';
} else {
     $wgServer          = 'http://' . $langcode . '.' . $project . '.site';     
     $wgMetaNamespace   = $project;
}
$wgSitename             = $wiki;

## System Messages
# Want MediaWiki:Copyright to redirect to MediaWiki:Wikimedia-copyright
#$wgRightsText           = 'MediaWiki:Copyright';

## Images
# local repository - /var/lib/wp-mirror-mediawiki/images/wikipedia/simple
$wgEnableUploads        = true;
$wgUploadDirectory      = $IP . '/images/' . $project . '/' . $langcode;
$wgUploadPath           = $wgScriptPath . '/images/' . $project . '/' . $langcode;

# remote repository - /var/lib/wp-mirror-mediawiki/images/wikipedia/commons
$wgSharedUploadDBname   = 'commonswiki';
$wgSharedUploadDirectory= $IP . '/images/wikipedia/commons';
$wgSharedUploadPath     = $wgScriptPath . '/images/wikipedia/commons';
$wgForeignFileRepos[]   = array(
    'class'            => 'ForeignDBViaLBRepo',
    'name'             => $wgSharedUploadDBname,
    'url'              => $wgSharedUploadPath,
    'directory'        => $wgSharedUploadDirectory,
    'hashLevels'       => 2, // This must be the same for all wikis in family
    'dbType'           => $wgDBtype,
    'dbServer'         => $wgDBserver,
    'dbUser'           => $wgDBuser,
    'dbPassword'       => $wgDBpassword,
    'dbFlags'          => DBO_DEFAULT,
    'dbName'           => $wgSharedUploadDBname,
    'tablePrefix'      => '',
    'hasSharedCache'   => false,
    'descBaseUrl'      => 'http://commons.wikipedia.site/index.php/Image:',
    'fetchDescription' => false,
    'wiki'             => $wgSharedUploadDBname,
);

# thumb
$wgUseImageMagick       = true;
$wgImageMagickConvertCommand = '/usr/bin/convert';
$wgCustomConvertCommand = false;
$wgSVGConverter         = 'ImageMagick';
#$wgUseImageMagick       = false;
#$wgCustomConvertCommand = '/usr/bin/gm convert %s -resize %wx%h %d';
#$wgSVGConverter         = 'inkscape';

## Load balancer - preferred by `wikidata' and by `TimedMediaHandler'
$wgLBFactoryConf        = array(
    'class'            => 'LBFactoryMulti',
    'serverTemplate'   => array(
                            'dbname'       => $wgDBname,
                            'user'         => $wgDBuser,
                            'password'     => $wgDBpassword,
                            'type'         => 'mysql',
                            'flags'        => DBO_DEFAULT | DBO_DEBUG,
                            'max lag'      => 30,
                            'fakeSlaveLag' => 1,
                          ),
    'sectionLoads'     => array(
                            'DEFAULT'      => array( 'localhost'  => 1,
                                                     'local1'     => 1,
                                                   ),
                            'repo'         => array( 'local2'     => 1,
                                                     'local3'     => 1,
                                                   ),
                          ),
    'sectionsByDB'     => array(
                            $wgDBname      => 'DEFAULT',
                            'wikidatawiki' => 'repo',
			  ),
    'hostsByName'      => array(
                            'localhost'    => '127.0.0.1:3306',
                            'local1'       => '127.0.2.1',
                            'local2'       => '127.0.2.2',
                            'local3'       => '127.0.2.3',
			  ),
    'masterTemplateOverrides' => array ( 'fakeMaster' => true ),
);
$wgAllDBsAreLocalhost   = true;

## Icons
$wgFavicon              = $wgScriptPath . '/favicon.ico';
$wgLogo                 = $wgScriptPath . '/wp-mirror.png';

## Extensions
$wgExtensionAssetsPath  = $wgScriptPath . '/extensions';
# CodeEditor
$wgCodeEditorEnableCore = true;
$wgScribuntoUseCodeEditor = true;

# EasyTimeline
putenv("GDFONTPATH=/usr/share/fonts/truetype/freefont");

# LocalisationUpdate
$wgLocalisationUpdateDirectory = $IP . '/cache';

# Math
$wgMathValidModes[]     = MW_MATH_MATHJAX;
$wgUseMathJax           = true;
$wgDefaultUserOptions['math'] = MW_MATH_MATHJAX;

# Misc
$wgUseTidy              = true;
$wgLocalInterwiki       = true;
$wgInterwikiMagic       = true;
$wgHideInterlanguageLinks = false;
#$wgLanguageCode         = $langcode;

# MobileFrontend
$wgMFAutodetectMobileView = true;
#$wgMobileUrlTemplate    = '%h0.m.%h1.%h2';

# OpenSearchXml
$wgEnableMWSuggest      = true;

# PagedTiffHandler
$wgImageMagickIdentifyCommand = '/usr/bin/identify';
$wgTiffUseExiv          = true;
$wgTiffExivCommand      = '/usr/bin/exiv2';
$wgTiffUseVips          = true;
$wgTiffVipsCommand      = '/usr/bin/vips';

# PdfHandler
$wgPdfProcessor         = 'gs';
$wgPdfPostProcessor     = $wgImageMagickConvertCommand;
$wgPdfInfo              = 'pdfinfo';
$wgFileExtensions[]     = 'pdf';

# Score
$wgScoreLilyPond        = '/usr/bin/lilypond';
$wgScoreAbc2Ly          = '/usr/bin/abc2ly';
$wgScoreTimidity        = '/usr/bin/timidity';
$wgScoreTrim            = true;

# Scribunto
$wgScribuntoDefaultEngine = 'luastandalone';
$wgScribuntoEngineConf['luastandalone']['errorFile'] = "/tmp/lua-error.log";
$wgScribuntoEngineConf['luastandalone']['luaPath'] = '/usr/bin/lua5.1';
$wgScribuntoUseGeSHi    = true;
$wgShowExceptionDetails = true;

# TemplateData
$wgTemplateDataUseGUI   = false;

# TimedMediaHandler (not enabled due to bug)
ini_set( 'include_path', 
	 ".:$IP:$IP/includes:$IP/languages:/usr/share/php" .
	 PATH_SEPARATOR .
	 ini_get( 'include_path' ) );
$wgVideoPlayerSkin      = 'kskin';
$wgEnableTranscode      = true;
$wgEnableNiceBackgroundTranscodeJobs = true;
$wgFFmpeg2theoraLocation= '/usr/bin/ffmpeg2theora';
$wgFFmpegLocation       = '/usr/bin/avconv';
$wgOggThumbLocation     = '/usr/bin/oggThumb';

# Translate
$wgGroupPermissions['user']['translate']               = true;
$wgGroupPermissions['user']['translate-messagereview'] = true;
$wgGroupPermissions['user']['translate-groupreview']   = true;
$wgGroupPermissions['user']['translate-import']        = true;
$wgGroupPermissions['sysop']['pagetranslation']        = true;
$wgGroupPermissions['sysop']['translate-manage']       = true;
$wgTranslateDocumentationLanguageCode                  = 'qqq';
$wgExtraLanguageNames['qqq']         = 'Message documentation';

# UniversalLanguageSelector
$wgULSEnable            = true;
$wgULSGeoService        = false;
$wgULSPosition          = 'interlanguage';
#$wgULSPosition          = 'personal';

# VipsScaler
$wgVipsCommand          = '/usr/bin/vips';

# VisualEditor
$wgDefaultUserOptions['visualeditor-enable'] = 1;
$wgHiddenPrefs[]        = 'visualeditor-enable';

# WikiEditor
$wgDefaultUserOptions['usebetatoolbar']     = 1;
$wgDefaultUserOptions['usebetatoolbar-cgd'] = 1;
$wgDefaultUserOptions['wikieditor-preview'] = 1;
$wgDefaultUserOptions['wikieditor-publish'] = 1;

## Extensions not configured
# CirrusSearch
# Elastica
# GeoData


## Wikidata
# wikidata repo
putenv( "MW_INSTALL_PATH=$IP" );
#define( 'WB_EXPERIMENTAL_FEATURES', true );
$wgEnableWikibaseRepo   = true;
$wgEnableWikibaseClient = true;
$wmgUseWikibaseRepo     = true;
$wmgUseWikibaseClient   = true;
require_once( "$IP/extensions/Wikidata/Wikidata.php" );
#require_once( "$IP/extensions/Wikidata/extensions/Wikibase/repo/ExampleSettings.php" );
$wgContentHandlerUseDB  = true;
define( 'WB_NS_PROPERTY',      120 );
define( 'WB_NS_PROPERTY_TALK', 121 );
$wgNamespaceAliases['Item']               = NS_MAIN;
$wgNamespaceAliases['Item_talk']          = NS_TALK;
$wgNamespaceAliases['Wikidata']           = NS_PROJECT;
$wgNamespaceAliases['Wikidata_talk']      = NS_PROJECT_TALK;
$wgExtraNamespaces[WB_NS_PROPERTY]        = 'Property';
$wgExtraNamespaces[WB_NS_PROPERTY_TALK]   = 'Property_talk';
$wgNamespacesToBeSearchedDefault[WB_NS_PROPERTY] = true;
#$wgNamespaceContentModels[NS_MAIN]        = CONTENT_MODEL_WIKIBASE_ITEM;
$wgNamespaceContentModels[WB_NS_PROPERTY] = CONTENT_MODEL_WIKIBASE_PROPERTY;
#$wgWBRepoSettings['entityNamespaces'][CONTENT_MODEL_WIKIBASE_ITEM] = NS_MAIN;
$wgWBRepoSettings['entityNamespaces'][CONTENT_MODEL_WIKIBASE_PROPERTY] = WB_NS_PROPERTY;
$wgGroupPermissions['*']['item-term']       = true;
$wgGroupPermissions['*']['item-merge']      = true;
$wgGroupPermissions['*']['property-term']   = true;
$wgGroupPermissions['*']['property-create'] = true;

# wikidata client
$wgWBClientSettings['repoNamespaces']     = array(
          'wikibase-item'     => '',
          'wikibase-property' => 'Property',
);
$wgWBClientSettings['siteLocalID']        = $wgLanguageCode;
$wgWBClientSettings['repoUrl']            = 'http://www.wikidata.site';
$wgWBClientSettings['repoArticlePath']    = '/wiki/$1';
$wgWBClientSettings['repoScriptPath']     = '/w';
$wgWBClientSettings['repoDatabase']       = 'wikidatawiki';
$wgWBClientSettings['siteGlobalID']       = $wgDBname;
$wgWBClientSettings['repoSiteId']         = 'wikidatawiki';
$wgWBClientSettings['siteGroup']          = $project;

# wb_changes_dispatch - not really needed for a mirror
#$wgWBRepoSettings['clientDbList']         = array(
#				      'simplewiki',      'simplewiktionary',
#				      'zuwiki',          'zuwiktionary', );
#$wgWBRepoSettings['localClientDatabases'] = array(
#				      'simplewiki'       => 'simplewiki',
#				      'simplewiktionary' => 'simplewiktionary',
#				      'zuwiki'           => 'zuwiki',
#				      'zuwiktionary'     => 'zuwiktionary', );
$wgWBClientSettings['changesDatabase']    = 'wikidatawiki';


## Caching
# For testing, set to false.  For production, set to true.
$wgEnableParserCache    = false;
$wgCachePages           = false;
# For MobileFrontend
$wgUseFileCache         = false;

## Debug
# SQL errors
$wgShowSQLErrors        = true;
$wgDebugComments        = true;
$wgShowDBErrorBacktrace = true;

# PHP errors
error_reporting( E_ERROR | E_WARNING | E_PARSE );
ini_set( 'display_errors', 1 );
